#import "Controller.h"
#import "DataContainer.h"
#import "KeyPress.h"
#import "ServiceUSBToolbox.h"

@implementation Controller
void NotificationProc(UInt32 inNotificationType,UInt8 inComparisonValue,void *userRefCon){
  id doIt;
  doIt = userRefCon;
  [doIt notification];  
}

- (void) notification{
  UInt32 BytesToRead;
  BytesToRead = ServiceUSB_GetBytesInReadBuffer(0,(ServiceUSB_DeviceIdentifierRef)0);        
  if (BytesToRead){
    char* theData=(char*)malloc(BytesToRead);
    if (theData!=nil){
      ServiceUSB_ReadBytesFromReadBuffer(0,theData,&BytesToRead,(ServiceUSB_DeviceIdentifierRef)0);	  
	  NSString *receive = [[NSString alloc] initWithBytes:theData length:BytesToRead encoding:NSASCIIStringEncoding];
      [container addData:[receive copy] from:1];
      free(theData);
    }
  }
}
- (IBAction)button1:(id)sender
{
  unsigned int i;
  if ([Key_Press AsciiHex] == ascii){
    [Key_Press translateInput:[textField1 stringValue]];
  }
  else{
    i = ([[textField1 stringValue] length] / 2) *2;
    [Key_Press translateInput:[[textField1 stringValue]substringToIndex:i]];
  }
}

- (IBAction)button2:(id)sender
{
  unsigned int i;
  if ([Key_Press AsciiHex] == ascii){
    [Key_Press translateInput:[textField2 stringValue]];
  }
  else{
    i = ([[textField1 stringValue] length] / 2) *2;
    [Key_Press translateInput:[[textField2 stringValue]substringToIndex:i]];
  }
}

- (IBAction)changeASCII:(id)sender{
  [Key_Press switchAsciiHex:[[sender selectedCell] tag]];
}

- (IBAction)changeBaud:(id)sender{
  ServiceUSB_SendVendorRequest(0,[[sender selectedCell] tag],0,kServiceUSB_UseDefaultDeviceIdentifier,kServiceUSB_DefaultTimeout);
}

- (IBAction)keyPressed:(NSString *)value{
  unsigned char bytesToSerial[40],i;
  [container addData:value from:0];
  UInt32 dataLen = [value length];
  if (dataLen > 40)
    dataLen = 40;
  for (i = 0; i < dataLen; i++)
    bytesToSerial[i] = (unsigned char) [value characterAtIndex:i];
  //ServiceUSB_WriteBytes(0,(void*) ([value lossyCString]),&dataLen,kServiceUSB_UseDefaultDeviceIdentifier,kServiceUSB_DefaultTimeout);
  ServiceUSB_WriteBytes(0,(void*) bytesToSerial,&dataLen,kServiceUSB_UseDefaultDeviceIdentifier,kServiceUSB_DefaultTimeout);
}

-(id) init{
    OSErr err;
    self = [super init];

    err = ServiceUSB_RegisterNotification(
        eServiceUSB_BytesInReadPipeNotification,
        0,
        NotificationProc,
        self,
        (ServiceUSB_DeviceIdentifierRef)0);
          
  return self;
}


@end
